KeyGeneratorSpi (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: javax.crypto, class: KeyGeneratorSpi
Keywords: javax.crypto.KeyGeneratorSpi class

# Class KeyGeneratorSpi

java.lang.Object
javax.crypto.KeyGeneratorSpi

public abstract class KeyGeneratorSpi extends Object
This class defines the Service Provider Interface (SPI) for the `KeyGenerator` class. All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a key generator for a particular algorithm.

In case the client does not explicitly initialize the KeyGenerator (via a call to an `init` method), each provider must supply (and document) a default initialization. See the Keysize Restriction sections of the JDK Providers document for information on the KeyGenerator defaults used by JDK providers. However, note that defaults may vary across different providers. Additionally, the default value for a provider may change in a future version. Therefore, it is recommended to explicitly initialize the KeyGenerator instead of relying on provider-specific defaults.

Since:
  1.4
See Also:
  - `SecretKey`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `KeyGeneratorSpi()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract SecretKey`
  `engineGenerateKey()`
  Generates a secret key.
  `protected abstract void`
  `engineInit(int keysize, SecureRandom random)`
  Initializes this key generator for a certain keysize, using the given source of randomness.
  `protected abstract void`
  `engineInit(SecureRandom random)`
  Initializes the key generator.
  `protected abstract void`
  `engineInit(AlgorithmParameterSpec params, SecureRandom random)`
  Initializes the key generator with the specified parameter set and a user-provided source of randomness.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### KeyGeneratorSpi

    public KeyGeneratorSpi()
    Constructor for subclasses to call.

- ## Method Details

  - ### engineInit

    protected abstract void engineInit(SecureRandom random)
    Initializes the key generator.
    Parameters:
      `random` - the source of randomness for this generator

  - ### engineInit

    protected abstract void engineInit(AlgorithmParameterSpec params, SecureRandom random) throws InvalidAlgorithmParameterException
    Initializes the key generator with the specified parameter set and a user-provided source of randomness.
    Parameters:
      `params` - the key generation parameters
      `random` - the source of randomness for this key generator
    Throws:
      `InvalidAlgorithmParameterException` - if `params` is inappropriate for this key generator

  - ### engineInit

    protected abstract void engineInit(int keysize, SecureRandom random)
    Initializes this key generator for a certain keysize, using the given source of randomness.
    Parameters:
      `keysize` - the keysize. This is an algorithm-specific metric, specified in number of bits.
      `random` - the source of randomness for this key generator
    Throws:
      `InvalidParameterException` - if the keysize is wrong or not supported.

  - ### engineGenerateKey

    protected abstract SecretKey engineGenerateKey()
    Generates a secret key.
    Returns:
      the new key